#!/usr/bin/env python3
# -*- coding: utf-8 -*-
# ----------------------------------------------------------------------------
# Created By  : Tof
# Created Date: 23/01/2024
# version ='6'
# ---------------------------------------------------------------------------
""" récupere les posreport sur un ftp :
			fait une synchro toutes les minutes à partir d'une heure ronde +5 minutes
			,récupère les archives si on n'était pas connecté pendant un moment,
			et copie les nouveaux fichiers dans le repertoire dcc de qtVlm
	les paramètre suivant sont à renseigner un peu plus bas:
	    ftp_host='???.???.???.???'
        ftp_user='???'
        ftp_password='???'
        ftp_directory='???'
        local_directory='/home/tof/.qtVlm/dcc'# répertoire où sont copiés les nouveaux fichier
        archives_directory='/home/tof/Arkea/Archives_posreports'# répertoire d'archive qui est synchronisé avec le serveur ftp

	"""
# ---------------------------------------------------------------------------
from ftplib import FTP
import os
import shutil
import schedule
import time
from datetime import datetime, timedelta

#A renseigner:
ftp_host='???.???.???.???'
ftp_user='???'
ftp_password='???'
ftp_directory='???'
local_directory='/home/tof/.qtVlm/dcc'# répertoire où sont copiés les nouveaux fichier
archives_directory='/home/tof/Arkea/Archives_posreports'# répertoire d'archive qui est synchronisé avec le serveur ftp

def synchroniser_ftp_local(ftp_host, ftp_user, ftp_password, ftp_directory, local_directory, archives_directory):
    # Connexion au serveur FTP
    ftp = FTP()
    ftp.connect(ftp_host)
    ftp.login(user=ftp_user, passwd=ftp_password)

    # Changer le répertoire de travail sur le serveur FTP
    ftp.cwd(ftp_directory)

    # Récupérer la liste des fichiers dans le répertoire FTP
    fichiers_ftp = ftp.nlst()

     # Vérifier les nouveaux fichiers et les copier localement
    for fichier in fichiers_ftp:
        chemin_local_source = os.path.join(local_directory, fichier)
        chemin_local_destination = os.path.join(archives_directory, fichier)

        # Vérifier si le fichier n'existe pas localement
        if not os.path.exists(chemin_local_destination):
            # Copier le fichier localement dans le répertoire de destination
            with open(chemin_local_destination, 'wb') as fichier_local_dest:
                ftp.retrbinary('RETR ' + fichier, fichier_local_dest.write)
            
            # Copier le fichier localement dans le répertoire local
            shutil.copy(chemin_local_destination, chemin_local_source)
            
            
            print("Nouveau fichier :    " + fichier)
            
    # Se déconnecter du serveur FTP
    ftp.quit()

def synchronisation_periodique():
    print("Synchronisation en cours...")
    synchroniser_ftp_local(
        ftp_host,
        ftp_user,
        ftp_password,
        ftp_directory,
        local_directory,
        archives_directory
    )

    maintenant_systeme = datetime.now()

    print("Synchronisation terminée à "+ f"{maintenant_systeme.strftime('%H:%M:%S')}")


# Effectuer la première synchronisation
synchronisation_periodique()
print("Attente jusqu'à l'heure ronde +4mn suivante.")

# Attendre jusqu'à l'heure ronde suivante
maintenant = datetime.now()
prochaine_heure_ronde = (maintenant + timedelta(hours=1)).replace(minute=4, second=0, microsecond=0)
attente_jusqu_a_prochaine_heure_ronde = (prochaine_heure_ronde - maintenant).total_seconds()
time.sleep(attente_jusqu_a_prochaine_heure_ronde)

while True:
    # Synchronisation toutes les minutes jusqu'à ce qu'un nouveau fichier soit récupéré
    while True:
        synchronisation_periodique()

        # Vérifier si de nouveaux fichiers ont été récupérés
        maintenant = datetime.now()
        fichiers_locaux = os.listdir(archives_directory)
        nouveaux_fichiers = [fichier for fichier in fichiers_locaux if maintenant - datetime.fromtimestamp(os.path.getctime(os.path.join(archives_directory, fichier))) < timedelta(minutes=1)]

        if nouveaux_fichiers:
            nombre_de_nouveaux_fichiers = len(nouveaux_fichiers)
            print(f"{nombre_de_nouveaux_fichiers} nouveau(x) fichier(s). Attente jusqu'à l'heure ronde +5mn suivante.")
            break

        time.sleep(60)  # Attendre une minute avant la prochaine synchronisation

    # Attendre jusqu'à l'heure ronde suivante
    maintenant = datetime.now()
    prochaine_heure_ronde = (maintenant + timedelta(hours=1)).replace(minute=5, second=0, microsecond=0)
    attente_jusqu_a_prochaine_heure_ronde = (prochaine_heure_ronde - maintenant).total_seconds()
    time.sleep(attente_jusqu_a_prochaine_heure_ronde)
